<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['gazelle.common.menu.MenuStatistics']}"/>
    <ui:param name="pageNameUrl" value="/administration/statistics.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['gazelle.common.menu.MenuStatistics']}"/>

    <ui:define name="body">
        <s:div styleClass="panel panel-default" rendered="#{s:hasRole('admin_role')}">

            <div class="panel-heading">
                #{messages['net.ihe.gazelle.evs.ValidationOutcomesExportSummaryAsCsv']}
            </div>
            <div class="panel-body">

                    <h:form id="exportForm">
                        <h:commandLink styleClass="gzl-btn-blue"
                                       style="float:left;"
                                       action="#{statisticsBeanGui.exportValidations()}"
                                       value="#{messages['net.ihe.gazelle.evs.LaunchExport']}"
                                       execute="@this"/>
                        <h:inputHidden id="startDate" styleClass="gzl-date-input form-control" value="#{statisticsBeanGui.exportStartDate}">
                        </h:inputHidden>

                        <h:inputHidden id="endDate" styleClass="gzl-date-input form-control" value="#{statisticsBeanGui.exportEndDate}">
                        </h:inputHidden>
                    </h:form>

                    <s:span id="datePicker" styleClass="gzl-never-wrap form-inline">
                        <h:panelGroup>
                            <div id="dateInputs" class="input-group">
                                <div class="input-group-addon"><span class="gzl-icon-calendar"/></div>
                                <h:inputText id="picker" styleClass="gzl-date-input form-control">
                                </h:inputText>

                                <a4j:jsFunction name="refresh" render="datePicker"
                                                execute="startDate,endDate,datePicker"/>
                            </div>

                            <script>
                                var datePickerOptions = {};
                                datePickerOptions.minDate = '01/01/1990';
                                datePickerOptions.showDropdowns = true;

                                datePickerOptions.linkedCalendars = false;
                                datePickerOptions.locale = {
                                    applyLabel: #{messages['gazelle.common.Apply']},
                                    cancelLabel: #{messages['gazelle.common.Cancel']},
                                    weekLabel: #{messages['gazelle.common.W']},
                                    customRangeLabel: #{messages['gazelle.common.CustomRange']},
                                    format: 'DD/MM/YYYY'
                                };
                                datePickerOptions.ranges = {
                                #{messages['gazelle.common.Today']}: [moment(), moment()],
                                #{messages['gazelle.common.Yesterday']}: [moment().subtract(1, "days"), moment().subtract(1, "days")],
                                #{messages['gazelle.common.Last7']}: [moment().subtract(6, "days"), moment()],
                                #{messages['gazelle.common.Last30']}: [moment().subtract(29, "days"), moment()],
                                #{messages['gazelle.common.ThisMonth']}: [moment().startOf("month"), moment().endOf("month")],
                                #{messages['gazelle.common.LastMonth']}: [moment().subtract(1, "month").startOf("month"), moment().subtract(1, "month").endOf("month")],
                                #{messages['gazelle.common.ThisYear']}: [moment().startOf("year"), moment()],
                                #{messages['gazelle.common.LastYear']}: [moment().subtract(1, "year").startOf("year"), moment().subtract(1, "year").endOf("year")],
                                };
                                datePickerOptions.startDate = moment(#{statisticsBeanGui.exportStartDate.getTime()}).locale('#{localeSelector.localeString}');
                                datePickerOptions.endDate = moment(#{statisticsBeanGui.exportEndDate.getTime()}).locale('#{localeSelector.localeString}');
                            </script>

                            <script>
                                jq162(document).ready(function () {
                                    moment.locale('#{localeSelector.localeString}');
                                    jq162('#picker').daterangepicker(datePickerOptions);

                                    jq162('#picker').on('apply.daterangepicker', function (ev, picker) {
                                        jq162('input[id*=startDate]').val(picker.startDate.locale('#{localeSelector.localeString}').format(datePickerOptions.locale.format));
                                        jq162('input[id*=endDate]').val(picker.endDate.locale('#{localeSelector.localeString}').format(datePickerOptions.locale.format));
                                    });
                                });
                            </script>

                        </h:panelGroup>
                    </s:span>
            </div>
        </s:div>

        <div class="panel panel-default">
            <div class="panel-heading">
                #{messages['net.ihe.gazelle.evs.ValidationOutcomesTotal']}
            </div>
            <div class="panel-body">
                <h:form>
                    <f:facet name="header">#{messages['net.ihe.gazelle.evs.StatisticsOnEVSClientUsage']}</f:facet>
                    <s:span styleClass="gzl-icon-exclamation-triangle"/>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.evs.ResultsDisplayedAreTakingIntoAccountValidationAt']}"/>
                    <br/>

                    <rich:dataTable value="#{statisticsBeanGui.totalDataRow}" var="totalDataRow"
                                    styleClass="table table-striped table-responsive">
                        <g:column>
                            <ui:define name="header"></ui:define>
                            <h:outputText value="#{totalDataRow.name}" style="font-weight:bold;"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.nbOfvalidations']}</ui:define>
                            #{totalDataRow.numberOfValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.NumberOfGUIValidations']}</ui:define>
                            #{totalDataRow.numberOfGuiValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.NumberOfWSValidations']}</ui:define>
                            #{totalDataRow.numberOfWebServiceValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.passed']}</ui:define>
                            #{totalDataRow.numberOfPassedValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.failed']}</ui:define>
                            #{totalDataRow.numberOfFailedValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.UNDEFINED']}</ui:define>
                            #{totalDataRow.numberOfUndefinedValidations}
                        </g:column>
                    </rich:dataTable>
                </h:form>
            </div>
        </div>

        <div class="panel panel-default">
            <div class="panel-heading">
                #{messages['net.ihe.gazelle.evs.ValidationOutcomesPerStandard']}
            </div>
            <div class="panel-body">
                <h:form>
                    <f:facet name="header">#{messages['net.ihe.gazelle.evs.StatisticsOnEVSClientUsage']}</f:facet>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.evs.ThisPageDisplaysStatisticsAtAVeryHighLevelIfYouW']}"/>
                    <br/>
                    <s:span styleClass="gzl-icon-exclamation-triangle"/>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.evs.AValidationOutcomeCanBeCountedInSeveralReference']}"/>
                    <br/>
                    <rich:dataTable value="#{statisticsBeanGui.totalDataRowGroupByReferencedStandard}" var="dataRow"
                                    styleClass="table table-striped table-responsive">
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.Menu']}</ui:define>
                            #{empty dataRow.menu ? 'no active menu' : dataRow.menu}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.admin.referenced.standards']}</ui:define>
                            <s:link view="/common/statisticsByStandard.seam">
                            <f:param name="#{statisticsBeanGui.getParameterNameForStandardId()}" value="#{dataRow.standardId}"/>
                                <h:outputText value="#{dataRow.name}" style="font-weight:bold;"/>
                            </s:link>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.nbOfvalidations']}</ui:define>
                            #{dataRow.numberOfValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.NumberOfGUIValidations']}</ui:define>
                            #{dataRow.numberOfGuiValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.NumberOfWSValidations']}</ui:define>
                            #{dataRow.numberOfWebServiceValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.passed']}</ui:define>
                            #{dataRow.numberOfPassedValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.failed']}</ui:define>
                            #{dataRow.numberOfFailedValidations}
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.UNDEFINED']}</ui:define>
                            #{dataRow.numberOfUndefinedValidations}
                        </g:column>
                        <!-- TODO : What do do ? -->
                        <!--<g:column
                                rendered="#{s:hasRole('admin_role') and not statisticsManager.getUpdateStatus().equals('done')}">
                            <ui:define name="header">#{messages['gazelle.common.Action']}</ui:define>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.UpdateListOfCountries']}"
                                               actionListener="#{statisticsManager.updateCountries(stat[8])}"/>
                        </g:column> -->
                    </rich:dataTable>
                </h:form>
                <p>
                    <a href="worldMap.seam" target="blank">#{messages['net.ihe.gazelle.evs.SeeWhereUsersAreFrom']}</a>
                </p>
            </div>
        </div>

    </ui:define>
</ui:composition>
